
    .cdecls C, list, "msp430.h" ; this allows us to use C headers

    .text                       ; locates code in 'text' section

	.global q1_15_mul
	
x		.set			R12
y		.set			R13

;Q1.15 style 16x16=>16 multiply with half bit rounding of the result.
;int16_t q1_15_mulr(int16_t x, int16_t y)
q1_15_mul:
	;.if $defined(__MSP430_HAS_MPY32__)
    mov     x,&MPYS
    mov     y,&OP2
    mov     &RESHI,x
    mov     &RESLO,y
    ;Shift to Q1.15 format (i.e. the Ftop 16 bits are returned)
    rla     y
    rlc     x
	;.endif

	.if $defined(__LARGE_DATA_MODEL__)
    retx
	.else
    ret
    .endif

    .end
    
