
    .cdecls C, list, "msp430.h" ; this allows us to use C headers

    .text                       ; locates code in 'text' section

	.global mul48u_32_16

x_ls	.set			R12
x_ms	.set			R13
y		.set			R14

;uint32_t mul48u_32_16(uint32_t x, uint16_t y);
mul48u_32_16:
	.if $defined(__MSP430_HAS_MPY32__)
    push.w  SR
    dint
    nop
    mov.w   x_ls,&MPYS32L
    mov.w   x_ms,&MPYS32H
    mov.w   y,&OP2L
    mov.w   #0,&OP2H
    nop
    nop
    mov.w   &RES1,x_ls
    mov.w   &RES2,x_ms
    pop.w   SR
	.endif
	.if $defined(__MSP430_HAS_MPY__)
    push.w  SR
    dint
    nop
    mov.w   y,&MPY
    mov.w   x_ls,&OP2
    nop
    nop
    mov.w   &RESHI,x_ls
    mov.w   x_ms,&OP2
    mov.w   #0,x_ms
    add.w   &RESLO,x_ls
    addc.w  &RESHI,x_ms
	pop.w   SR
	.endif

	.if $defined(__LARGE_DATA_MODEL__)
    retx
	.else
    ret
    .endif

    .end

