
    .cdecls C, list, "msp430.h" ; this allows us to use C headers

    .text                       ; locates code in 'text' section

	.global sqac48_16
	
z		.set			R12
x		.set			R13
tmp		.set			R15

; Square and accumulate x into z
;void sqac48_16(register int16_t z[3], register int16_t x)
sqac48_16:
	mov.w   x,&MPYS
	mov.w   x,&OP2
	mov.w   #RESLO,tmp
	add.w   @tmp+,0(z)
	addc.w  @tmp+,2(z)
	addc.w  @tmp,4(z)

	.if $defined(__LARGE_DATA_MODEL__)
    retx
	.else
    ret
    .endif
    .end
